/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___QHFuncSTACK_H_
#define ___QHFuncSTACK_H_

typedef struct _QHFuncStack
{
    QHFunc* elem;
    int ptr;
    int size;
} QHFuncStack;

#define isemptyQHFuncStack(st) ((st)->ptr == 0)

/* make a new stack */
void makeQHFuncStack(QHFuncStack* st, int size);

/* delete a stack */
void deleteQHFuncStack(QHFuncStack* st);

/* resize a stack */
void resizeQHFuncStack(QHFuncStack* st, int size);

/* empty stack */
void emptyQHFuncStack(QHFuncStack* st);

/* push-down */
void pushQHFuncStack(QHFuncStack* st, QHFunc value);

/* stack-top */
QHFunc topQHFuncStack(QHFuncStack* st);

/* pop-up */
QHFunc popQHFuncStack(QHFuncStack* st);


#endif /* ___STACK_H_ */
