/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___SWRBuffSTACK_H_
#define ___SWRBuffSTACK_H_

typedef struct _SWRBuffStack
{
    SWRBuff* elem;
    int ptr;
    int size;
} SWRBuffStack;

#define isemptySWRBuffStack(st) ((st)->ptr == 0)

/* make a new stack */
void makeSWRBuffStack(SWRBuffStack* st, int size);

/* delete a stack */
void deleteSWRBuffStack(SWRBuffStack* st);

/* resize a stack */
void resizeSWRBuffStack(SWRBuffStack* st, int size);

/* empty stack */
void emptySWRBuffStack(SWRBuffStack* st);

/* push-down */
void pushSWRBuffStack(SWRBuffStack* st, SWRBuff value);

/* stack-top */
SWRBuff topSWRBuffStack(SWRBuffStack* st);

/* pop-up */
SWRBuff popSWRBuffStack(SWRBuffStack* st);


#endif /* ___STACK_H_ */
