/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___SwitchStmtSTACK_H_
#define ___SwitchStmtSTACK_H_

typedef struct _SwitchStmtStack
{
    SwitchStmt* elem;
    int ptr;
    int size;
} SwitchStmtStack;

#define isemptySwitchStmtStack(st) ((st)->ptr == 0)

/* make a new stack */
void makeSwitchStmtStack(SwitchStmtStack* st, int size);

/* delete a stack */
void deleteSwitchStmtStack(SwitchStmtStack* st);

/* resize a stack */
void resizeSwitchStmtStack(SwitchStmtStack* st, int size);

/* empty stack */
void emptySwitchStmtStack(SwitchStmtStack* st);

/* push-down */
void pushSwitchStmtStack(SwitchStmtStack* st, SwitchStmt value);

/* stack-top */
SwitchStmt topSwitchStmtStack(SwitchStmtStack* st);

/* pop-up */
SwitchStmt popSwitchStmtStack(SwitchStmtStack* st);


#endif /* ___STACK_H_ */
