/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___char_ptrSTACK_H_
#define ___char_ptrSTACK_H_

typedef struct _char_ptrStack
{
    char_ptr* elem;
    int ptr;
    int size;
} char_ptrStack;

#define isemptychar_ptrStack(st) ((st)->ptr == 0)

/* make a new stack */
void makechar_ptrStack(char_ptrStack* st, int size);

/* delete a stack */
void deletechar_ptrStack(char_ptrStack* st);

/* resize a stack */
void resizechar_ptrStack(char_ptrStack* st, int size);

/* empty stack */
void emptychar_ptrStack(char_ptrStack* st);

/* push-down */
void pushchar_ptrStack(char_ptrStack* st, char_ptr value);

/* stack-top */
char_ptr topchar_ptrStack(char_ptrStack* st);

/* pop-up */
char_ptr popchar_ptrStack(char_ptrStack* st);


#endif /* ___STACK_H_ */
