/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___DEFS_H_
#define ___DEFS_H_

#ifndef False
#define False 0
#endif

#ifndef True
#define True 1
#endif

#ifndef Bool
#define Bool int
#endif

#ifndef None
#define None 0
#endif

#define BETWEEN(a, b, c) ((a) <= (b) && (b) <= (c))

#ifndef MAX
#define MAX(a, b)        ((a) < (b) ? (b) : (a))
#endif

#ifndef MIN
#define MIN(a, b)        ((a) > (b) ? (b) : (a))
#endif

#define EXPAND_MEMORY_IF_OVERFLOW(type, ptr, size, limit)\
    if((size) >= (limit))\
    {\
	ptr = (type *)xcrealloc(ptr, sizeof(type) * (size), sizeof(type) * ((limit) + (size)));\
	(limit) += (size);\
    }

#endif /* ___DEFS_H_ */
