/* Copyright (c) 1995, Masanao Izumo */

#include <stdio.h>
#include <string.h>
#include "common.h"

#define HELPER QHLIBDIR "/docs/help"

void keyword_helper(int argc, char** argv)
{
    FILE* fp;
    char buff[BUFSIZ];
    char com[BUFSIZ];
    int i;

    strcpy(com, HELPER " -libdir " QHLIBDIR);
    for(i = 0; i < argc; i++)
    {
	strcat(com, " ");
	strcat(com, argv[i]);
    }

    if((fp = popen(com, "r")) == NULL)
    {
	perror(com);
	qhexit(1);
    }

    while(fgets(buff, BUFSIZ, fp))
	printf("%s", buff);

    pclose(fp);
}
