/* Copyright 1994 by Masanao Izumo, in the Kanagawa University. */

#include <stdio.h>
#include <stdlib.h>
#include "common.h"
#include "opstr.h"
static char* op_defs[] = {
"first_instruction",
"nop",
"add",
"sub",
"mul",
"div",
"rem",
"atan2",
"rand2",
"complex_op",
"logor",
"logand",
"llshift",
"lrshift",
"alshift",
"arshift",
"pow",
"eq",
"nq",
"le",
"lt",
"ge",
"gt",
"aassign",
"sassign",
"massign",
"dassign",
"rassign",
"assign",
"sin",
"cos",
"tan",
"asin",
"acos",
"atan",
"sinh",
"cosh",
"tanh",
"asinh",
"acosh",
"atanh",
"abs",
"floor",
"ceil",
"exp",
"log",
"log10",
"log2",
"sqrt",
"rand0",
"rand1",
"int_op",
"real_op",
"image_op",
"conjugate",
"arg",
"uminus",
"getlineop",
"commandop",
"addr",
"indir",
"lognot",
"not",
"notnot",
"zero",
"one",
"structof",
"sizeof_op",
"xinc",
"incx",
"xdec",
"decx",
"last_operator",
"ipush",
"ipush2",
"ipush3",
"param2",
"param3",
"call",
"callext",
"funcall",
"ascref",
"ascset",
"aref1",
"aref",
"aaset",
"asset",
"amset",
"adset",
"arset",
"aset",
"axinc",
"aincx",
"axdec",
"adecx",
"aindir",
"param",
"ifgoto",
"ifngoto",
"ifeqgoto",
"ifnqgoto",
"iflegoto",
"ifltgoto",
"ifgegoto",
"ifgtgoto",
"goto",
"list_op",
"stref",
"stset",
"return",
"end",
"write",
"new",
"ascnew",
"strnew",
"sttnew",
"typeof",
"atypeof",
"dimension",
"arraysize",
"exit",
"argv",
"system",
"sleep",
"rand",
"srand",
"time",
"clock",
"expand_cell_space",
"clear",
"clone",
"equal",
"strcpy",
"strncpy",
"strcat",
"strcmp",
"strncmp",
"strlen",
"strdup",
"chop",
"bswrite",
"swrite",
"eswrite",
"atoi",
"ator",
"atoc",
"gopen",
"gclose",
"gwindow",
"gscreen",
"gcopy",
"gcopy_area",
"gbacking_store",
"gsync",
"gclear",
"gtitle_name",
"gicon_name",
"gflush",
"gtext_width",
"gtext_height",
"gpoint",
"gbell",
"gline",
"gline2",
"gpset",
"gbox",
"gfbox",
"gpoly",
"gfpoly",
"gcircle",
"gfcircle",
"garc",
"gfarc",
"gstring",
"gspline",
"gfspline",
"gfont",
"gjfont",
"glookup_color",
"gsetdash",
"gcolor_name",
"gcolor_rgb",
"gcolor_fg",
"gpen",
"gpen3",
"gbutton",
"gkey",
"gpause",
"gpause1",
"gpointer",
"gpixel_per_mmx",
"gpixel_per_mmy",
"gdisplay_width",
"gdisplay_height",
"gresize_screen",
"gselect_input",
"gvisualize_screen",
"xfopen",
"xfclose",
"xfwrite2",
"xfwrite3",
"xfread",
"xfgetc",
"xfputc",
"xftrunc",
"xfseek",
"xpopen",
"xfcreate",
"xfdelete",
"car",
"cdr",
"cons",
"rplaca",
"rplacd",
};
char* opstr(int op)
{
    return op_defs[op - FIRST_INSTRUCTION];
}
