/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___QHLEX_H_
#define ___QHLEX_H_

/* filename is NULL, read from stdin */
void qhfileopen(const char* filename);
void qhfileclose(void);

void cpp_command(const char* string);

int qhstringrep(const char* text);

char* string_expand(char *t, const char *s);
/* expand string */

char* string_unexpand(char *t, const char *s);
/* unexpand string */

int char_code_convert(const char* s);
/* expand char */

void set_current_textpos(QHTextPos* tp);
/* set the current text position */

int int_convert(const char* s);
/* 0  : 8-base
 * 0x : 16-base
 * others: 10-base
 */

char* module_name_string(long module, long name);

extern int qhlineno;
extern int qhfilename;
extern FILE *yyin, *yyout;
extern int yylex(void);
extern Bool isqhfileopen;


#endif /* ___QHLEX_H_ */
