#ifndef ___QHSTRING_H_
#define ___QHSTRING_H_

#define IS_QHSTRING(qhobj) ((qhobj)->type == QH_String)

QHString* alloc_constant_string(const char* str);
/* allocate new string.
 * if memory is empty, begin the garbage-collection */

QHString* alloc_string(void);
QHString* clone_string(const QHString *x);
Bool equal_string(const QHString* s1, const QHString* s2);
Bool touch_string(QHString* s, int align);

#endif /* ___QHSTRING_H_ */
