/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___XMALLOC_H_
#define ___XMALLOC_H_

#ifndef ___XMALLOC_MACROS_
void* xmalloc(int size);
void* xcalloc(int nelem, int elsize);
void* xrealloc(void* p, int size);
char* xstrdup(const char* s);
void  xfree(void* p);
#endif

void* xcrealloc(void* p, int old_size, int new_size);

extern char* flexible_buff;
extern int   flexible_buff_size;
extern int   flexible_buff_ptr;

void clear_flexible_buff(void);
void need_flexible_buff(int size);
void add_string_to_flexible_buff(const char* s);
char* get_flexible_buff(void);

#endif /* ___XMALLOC_H_ */

