/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___ASSOCARR_HP_
#define ___ASSOCARR_HP_

#define DEFAULT_QHObjASSCO_TABLE_SIZE 1024

typedef struct _QHObjAssocArr
{
    int size;
    struct QHObjAssocArrNode** assoctab;
} QHObjAssocArr;

void makeQHObjAssocArr(QHObjAssocArr* arr, int size);
/* create a new association array */

void deleteQHObjAssocArr(QHObjAssocArr* arr);
/* delete an association array */

void installQHObjAssocArr(QHObjAssocArr* arr, const char* name, QHObj value);
/* install value */

QHObj* searchQHObjAssocArr(const QHObjAssocArr* arr, const char* name);
/* if it doesn't exist, returns NULL; otherwize returns opinter to value */

void mapQHObjAssocArr(QHObjAssocArr* arr, void (* mapfn)(const char* name, QHObj* value));
/* map function */

#endif /* ___ASSOCARR_HP_ */
