/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___CELL_H_
#define ___CELL_H_

void init_cell_object(void);
/* initialize cell object */

void free_cell_object(void);
/* free cell object */

CELL* alloc_cell(void);
/* allocate new CELL object
 * If CELL is exhausted, garbage-collection occurs.
 */

void garbage_collect(void);
/* garbage-collection */

int expand_CELL_space(int n);
/* increase the system CELL objects */

void reuse_data_block(struct data_block* block);

extern int count_of_garbage_collection;

#endif /* ___CELL_H_ */
