/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___ERROR_H_
#define ___ERROR_H_

int yyerror(const char* errmsg);
void yyerror2(const char* errmsg, QHTextPos* tp);
void yyerror3(const char* errmsg); /* don't display lineno and filename */
Bool check_redeclaration_farg(intStack* st, int name);
Bool check_expr(Tree* t);
void write_warning(const char* msg);
void write_warning_with_line(const char* msg, int line);

#endif /* ___ERROR_H_ */
