/* Copyright 1995 by Masanao Izumo, in the Kanagawa University. */

#include <stdio.h>
#include <stdlib.h>
#include "common.h"
#include "functab.h"
void (*functab[])() = {
qh_first_instruction,
qh_nop,
qh_add,
qh_sub,
qh_mul,
qh_div,
qh_rem,
qh_atan2,
qh_rand2,
qh_complex_op,
qh_logor,
qh_logand,
qh_llshift,
qh_lrshift,
qh_alshift,
qh_arshift,
qh_pow,
qh_eq,
qh_nq,
qh_le,
qh_lt,
qh_ge,
qh_gt,
qh_aassign,
qh_sassign,
qh_massign,
qh_dassign,
qh_rassign,
qh_assign,
qh_sin,
qh_cos,
qh_tan,
qh_asin,
qh_acos,
qh_atan,
qh_sinh,
qh_cosh,
qh_tanh,
qh_asinh,
qh_acosh,
qh_atanh,
qh_abs,
qh_floor,
qh_ceil,
qh_exp,
qh_log,
qh_log10,
qh_log2,
qh_sqrt,
qh_rand0,
qh_rand1,
qh_int_op,
qh_real_op,
qh_image_op,
qh_conjugate,
qh_arg,
qh_uminus,
qh_getlineop,
qh_commandop,
qh_addr,
qh_indir,
qh_lognot,
qh_not,
qh_notnot,
qh_zero,
qh_one,
qh_structof,
qh_sizeof_op,
qh_xinc,
qh_incx,
qh_xdec,
qh_decx,
qh_last_operator,
qh_ipush,
qh_ipush2,
qh_ipush3,
qh_param2,
qh_param3,
qh_call,
qh_callext,
qh_funcall,
qh_ascref,
qh_ascset,
qh_aref1,
qh_aref,
qh_aaset,
qh_asset,
qh_amset,
qh_adset,
qh_arset,
qh_aset,
qh_axinc,
qh_aincx,
qh_axdec,
qh_adecx,
qh_aindir,
qh_param,
qh_ifgoto,
qh_ifngoto,
qh_ifeqgoto,
qh_ifnqgoto,
qh_iflegoto,
qh_ifltgoto,
qh_ifgegoto,
qh_ifgtgoto,
qh_goto,
qh_list_op,
qh_stref,
qh_stset,
qh_return,
qh_end,
qh_write,
qh_new,
qh_ascnew,
qh_strnew,
qh_sttnew,
qh_typeof,
qh_atypeof,
qh_dimension,
qh_arraysize,
qh_exit,
qh_argv,
qh_system,
qh_sleep,
qh_rand,
qh_srand,
qh_time,
qh_clock,
qh_expand_cell_space,
qh_clear,
qh_clone,
qh_equal,
qh_strcpy,
qh_strncpy,
qh_strcat,
qh_strcmp,
qh_strncmp,
qh_strlen,
qh_strdup,
qh_chop,
qh_bswrite,
qh_swrite,
qh_eswrite,
qh_atoi,
qh_ator,
qh_atoc,
qh_gopen,
qh_gclose,
qh_gwindow,
qh_gscreen,
qh_gcopy,
qh_gcopy_area,
qh_gbacking_store,
qh_gsync,
qh_gclear,
qh_gtitle_name,
qh_gicon_name,
qh_gflush,
qh_gtext_width,
qh_gtext_height,
qh_gpoint,
qh_gbell,
qh_gline,
qh_gline2,
qh_gpset,
qh_gbox,
qh_gfbox,
qh_gpoly,
qh_gfpoly,
qh_gcircle,
qh_gfcircle,
qh_garc,
qh_gfarc,
qh_gstring,
qh_gspline,
qh_gfspline,
qh_gfont,
qh_gjfont,
qh_glookup_color,
qh_gsetdash,
qh_gcolor_name,
qh_gcolor_rgb,
qh_gcolor_fg,
qh_gpen,
qh_gpen3,
qh_gbutton,
qh_gkey,
qh_gpause,
qh_gpause1,
qh_gpointer,
qh_gpixel_per_mmx,
qh_gpixel_per_mmy,
qh_gdisplay_width,
qh_gdisplay_height,
qh_gresize_screen,
qh_gselect_input,
qh_gvisualize_screen,
qh_xfopen,
qh_xfclose,
qh_xfwrite2,
qh_xfwrite3,
qh_xfread,
qh_xfgetc,
qh_xfputc,
qh_xftrunc,
qh_xfseek,
qh_xpopen,
qh_xfcreate,
qh_xfdelete,
qh_car,
qh_cdr,
qh_cons,
qh_rplaca,
qh_rplacd,
};
