/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___intSTACK_H_
#define ___intSTACK_H_

typedef struct _intStack
{
    int* elem;
    int ptr;
    int size;
} intStack;

#define isemptyintStack(st) ((st)->ptr == 0)

/* make a new stack */
void makeintStack(intStack* st, int size);

/* delete a stack */
void deleteintStack(intStack* st);

/* resize a stack */
void resizeintStack(intStack* st, int size);

/* empty stack */
void emptyintStack(intStack* st);

/* push-down */
void pushintStack(intStack* st, int value);

/* stack-top */
int topintStack(intStack* st);

/* pop-up */
int popintStack(intStack* st);


#endif /* ___STACK_H_ */
