/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___NEWTEMP_H_
#define ___NEWTEMP_H_

#define IS_TEMP_SYM(sym) (((sym) != NULL) &&				\
			  ((sym) ->type == SYM_VAR) &&			\
			  (STRING((sym)->name)[0] == temp_prefix) &&	\
			  ((sym)->ref_cnt == 0))
			  

void init_temp(void);
void free_temp(void);

int  newtemp(void);
void reuse_temp(int name);
void reuse_if_temp_sym(Symbol* sym);

#ifdef CHECK_NEWTEMP
void write_newtemp_stack(void);
#endif

extern const int temp_prefix;


#endif /* ___NEWTEMP_H_ */
