/* Copyright (c) 1995, Masanao Izumo */

#ifndef ___QHTYPES_QHL_
#define ___QHTYPES_QHL_

enum qh_objact_types
{
				/* None */
    QH_Int     = 1,		/* integer */
    QH_Real    = 2,		/* real */
    QH_Complex = 3,		/* complex */
    QH_String  = 16,		/* string array object */
    QH_Any,			/* any object */
    QH_Array,			/* array */
    QH_AssocArray,		/* assoc array */
    QH_Keyword,			/* keyword object */
    QH_Struct,			/* struct */
    QH_List,			/* linked list */
    QH_ExtData,			/* external defined data */
    QH_LastType			/* last type number */
};

enum qh_keyword_types
{
    QH_Key_Null,                /* the only keyword in the current version */
    QH_NKeyWord                 /* number of keyword */
};

#endif /* ___QHTYPES_QHL_ */
