typedef union {
    int       ival;             /* integer value */
    QHTextPos tp;               /* text position */
    Tree*     t;                /* tree value */
    QuadList  q;                /* quad-list value */
    lex_atomdat atm;            /* atom represent */
} YYSTYPE;
#define	FIRST_INSTRUCTION	258
#define	NOP	259
#define	ADD	260
#define	SUB	261
#define	MUL	262
#define	DIV	263
#define	REM	264
#define	ATAN2	265
#define	RAND2	266
#define	COMPLEX_OP	267
#define	LOGOR	268
#define	LOGAND	269
#define	LLSHIFT	270
#define	LRSHIFT	271
#define	ALSHIFT	272
#define	ARSHIFT	273
#define	POW	274
#define	EQ	275
#define	NQ	276
#define	LE	277
#define	LT	278
#define	GE	279
#define	GT	280
#define	AASSIGN	281
#define	SASSIGN	282
#define	MASSIGN	283
#define	DASSIGN	284
#define	RASSIGN	285
#define	ASSIGN	286
#define	SIN	287
#define	COS	288
#define	TAN	289
#define	ASIN	290
#define	ACOS	291
#define	ATAN	292
#define	SINH	293
#define	COSH	294
#define	TANH	295
#define	ASINH	296
#define	ACOSH	297
#define	ATANH	298
#define	ABS	299
#define	FLOOR	300
#define	CEIL	301
#define	EXP	302
#define	LOG	303
#define	LOG10	304
#define	LOG2	305
#define	SQRT	306
#define	RAND0	307
#define	RAND1	308
#define	INT_OP	309
#define	REAL_OP	310
#define	IMAGE_OP	311
#define	CONJUGATE	312
#define	ARG	313
#define	UMINUS	314
#define	GETLINEOP	315
#define	COMMANDOP	316
#define	ADDR	317
#define	INDIR	318
#define	LOGNOT	319
#define	NOT	320
#define	NOTNOT	321
#define	ZERO	322
#define	ONE	323
#define	STRUCTOF	324
#define	SIZEOF_OP	325
#define	XINC	326
#define	INCX	327
#define	XDEC	328
#define	DECX	329
#define	LAST_OPERATOR	330
#define	IPUSH	331
#define	IPUSH2	332
#define	IPUSH3	333
#define	PARAM2	334
#define	PARAM3	335
#define	CALL	336
#define	CALLEXT	337
#define	FUNCALL	338
#define	ASCREF	339
#define	ASCSET	340
#define	AREF1	341
#define	AREF	342
#define	AASET	343
#define	ASSET	344
#define	AMSET	345
#define	ADSET	346
#define	ARSET	347
#define	ASET	348
#define	AXINC	349
#define	AINCX	350
#define	AXDEC	351
#define	ADECX	352
#define	AINDIR	353
#define	PARAM	354
#define	IFGOTO	355
#define	IFNGOTO	356
#define	IFEQGOTO	357
#define	IFNQGOTO	358
#define	IFLEGOTO	359
#define	IFLTGOTO	360
#define	IFGEGOTO	361
#define	IFGTGOTO	362
#define	GOTO	363
#define	LIST_OP	364
#define	STREF	365
#define	STSET	366
#define	RETURN	367
#define	END	368
#define	WRITE	369
#define	NEW	370
#define	ASCNEW	371
#define	STRNEW	372
#define	STTNEW	373
#define	TYPEOF	374
#define	ATYPEOF	375
#define	DIMENSION	376
#define	ARRAYSIZE	377
#define	EXIT	378
#define	ARGV	379
#define	SYSTEM	380
#define	SLEEP	381
#define	RAND	382
#define	SRAND	383
#define	TIME	384
#define	CLOCK	385
#define	EXPAND_CELL_SPACE	386
#define	CLEAR	387
#define	CLONE	388
#define	EQUAL	389
#define	STRCPY	390
#define	STRNCPY	391
#define	STRCAT	392
#define	STRCMP	393
#define	STRNCMP	394
#define	STRLEN	395
#define	STRDUP	396
#define	CHOP	397
#define	BSWRITE	398
#define	SWRITE	399
#define	ESWRITE	400
#define	ATOI	401
#define	ATOR	402
#define	ATOC	403
#define	GOPEN	404
#define	GCLOSE	405
#define	GWINDOW	406
#define	GSCREEN	407
#define	GCOPY	408
#define	GCOPY_AREA	409
#define	GBACKING_STORE	410
#define	GSYNC	411
#define	GCLEAR	412
#define	GTITLE_NAME	413
#define	GICON_NAME	414
#define	GFLUSH	415
#define	GTEXT_WIDTH	416
#define	GTEXT_HEIGHT	417
#define	GPOINT	418
#define	GBELL	419
#define	GLINE	420
#define	GLINE2	421
#define	GPSET	422
#define	GBOX	423
#define	GFBOX	424
#define	GPOLY	425
#define	GFPOLY	426
#define	GCIRCLE	427
#define	GFCIRCLE	428
#define	GARC	429
#define	GFARC	430
#define	GSTRING	431
#define	GSPLINE	432
#define	GFSPLINE	433
#define	GFONT	434
#define	GJFONT	435
#define	GLOOKUP_COLOR	436
#define	GSETDASH	437
#define	GCOLOR_NAME	438
#define	GCOLOR_RGB	439
#define	GCOLOR_FG	440
#define	GPEN	441
#define	GPEN3	442
#define	GBUTTON	443
#define	GKEY	444
#define	GPAUSE	445
#define	GPAUSE1	446
#define	GPOINTER	447
#define	GPIXEL_PER_MMX	448
#define	GPIXEL_PER_MMY	449
#define	GDISPLAY_WIDTH	450
#define	GDISPLAY_HEIGHT	451
#define	GRESIZE_SCREEN	452
#define	GSELECT_INPUT	453
#define	GVISUALIZE_SCREEN	454
#define	XFOPEN	455
#define	XFCLOSE	456
#define	XFWRITE2	457
#define	XFWRITE3	458
#define	XFREAD	459
#define	XFGETC	460
#define	XFPUTC	461
#define	XFTRUNC	462
#define	XFSEEK	463
#define	XPOPEN	464
#define	XFCREATE	465
#define	XFDELETE	466
#define	CAR	467
#define	CDR	468
#define	CONS	469
#define	RPLACA	470
#define	RPLACD	471
#define	LAST_INSTRUCTION	472
#define	IDENTIFIER	473
#define	INTEGER	474
#define	REAL	475
#define	IMNUMBER	476
#define	STR	477
#define	FUNCTION	478
#define	DOTDOTDOT	479
#define	GLOBAL	480
#define	MODULE	481
#define	MODULE_SPEC	482
#define	LOCAL	483
#define	LOADFN	484
#define	QH_EXTERN	485
#define	IF	486
#define	ELSE	487
#define	FOR	488
#define	DO	489
#define	WHILE	490
#define	BREAK	491
#define	CONTINUE	492
#define	LABEL	493
#define	INC_OP	494
#define	DEC_OP	495
#define	STRING_OP	496
#define	ANY_SPEC	497
#define	ASSOC_SPEC	498
#define	WRITELN	499
#define	OR	500
#define	AND	501
#define	SWITCH	502
#define	CASE	503
#define	DEFAULT	504
#define	PRAGMA	505
#define	MATHFUNC1	506
#define	MATHFUNC2	507
#define	QHKEYWORD	508
#define	STRUCT	509
#define	ENUM	510
#define	VOLATILE	511
#define	LOWER_THEN_ELSE	512
#define	LOWER_THEN_COND_OPERATOR	513


extern YYSTYPE yylval;
